.nolist
;.include "2313def.inc"
.include "8515def.inc"
.list

.equ	XTAL		=3686400;in Hz
;.equ	XTAL		=8000000;in Hz
;.equ	XTAL		=9830400;in Hz

.equ     baudrate = 9600          ;choose a baudrate
.equ     baudconstant = (XTAL/(16*baudrate))-1


.nolist

.def zero = r1
.def one  = r2

.def remll  = r8		; QUOT
.def remlh  = r9		; QUOTM
.def remhl  = r10		; QUOTH
.def remhh  = r11		; QUOTHH

.def temp2l = r20		; MANT2
.def temp2h = r21		; MANT2m
.def temp3l = r22		; MANT2h
.def temp3h = r23		; MANT2hh

.def templ = r16		; MANT1
.def temph = r17		; MANT1m

.def tosl = r24			; MANT1h
.def tosh = r25			; MANT1hh


.macro ldwi
	ldi	@0l, low( @1)
	ldi	@0h, high( @1)
.endm


.macro	outw
	out	@0h, @1h
	out	@0l, @1l
.endm

.macro	inw
	in	@0h, @1h
	in	@0l, @1l
.endm

.macro	pushw
	push	@0h
	push	@0l
.endm

.macro	popw
	pop	@0l
	pop	@0h
.endm


.macro	dpush
	st	-y, @0h
	st	-y, @0l
.endm

.macro	dpop
	ld	@0l, y+
	ld	@0h, y+
.endm


.macro	ldw
	mov	@0l, @1l
	mov	@0h, @1h
.endm


.macro	nextw
	ld	@0l, x+
	ld	@0h, x+
.endm

.macro	nextc
	ld	@0l, x+
	clr	@0h
.endm

.macro	pick
	ldd	@1l, y+@0
	ldd	@1h, y+@0 +1
.endm


.macro	addw
	add	@0l, @1l
	adc	@0h, @1h
.endm


.macro	subw
	sub	@0l, @1l
	sbc	@0h, @1h
.endm


.macro	andw
	and	@0l, @1l
	and	@0h, @1h
.endm


.macro	orw
	or	@0l, @1l
	or	@0h, @1h
.endm

.macro	xorw
	eor	@0l, @1l
	eor	@0h, @1h
.endm


.macro	notw
	com	@0l
	com	@0h
.endm


.macro	cmpw
	cp	@0l, @1l
	cpc	@0h, @1h
.endm

.macro	setfalse
	clr	tosl
	clr	tosh
.endm

.macro	settrue
	ldi	tosl, 0xff
	ldi	tosh, 0xff
.endm


.macro	getw
	ld	@0l, z+
	ld	@0h, z+
.endm

.macro	getc
	ld	@0l, z+
	clr	@0h
.endm


.macro	putw
	st	z+, @0l
	st	z+, @0h
.endm

.macro	putc
	st	z+, @0l
.endm


.macro	decw
	sub	@0l, one
	sub	@0h, zero
.endm


.macro	testz
	cp	@0l, zero
	cpc	@0h, zero
.endm

.macro	clrw
	clr	@0l
	clr	@0h
.endm


.list

.dseg

	.byte	0x200
csp:
	.byte	0x100
rsp:


.cseg


.equ bootStart = $400


	.cseg
.org 	0
	rjmp	_Main
	
.org	INT0addr	;=$001	;External Interrupt0 Vector Address
	reti

.org	INT1addr	;=$002	;External Interrupt1 Vector Address
;	rjmp	_RTOS_INT1
	reti

.org	ICP1addr	;=$003	;Input Capture1 Interrupt Vector Address
	reti

;.org	OC1addr		;=$004	;Output Compare1 Interrupt Vector Address
;	rjmp	oc1Timer1
	reti

.org	OVF1addr	;=$005	;Overflow1 Interrupt Vector Address
;	rjmp	_RTOS_OVF1
	reti

.org	OVF0addr	;=$006	;Overflow0 Interrupt Vector Address
;	rjmp	_RTOS_OVF0
	reti

.org	URXCaddr	;=$007	;UART Receive Complete Interrupt Vector Address
;	rjmp	_RTOS_URXC
	reti

.org	UDREaddr	;=$008	;UART Data Register Empty Interrupt Vector Address
	reti

.org	UTXCaddr	;=$009	;UART Transmit Complete Interrupt Vector Address
	reti

.org	ACIaddr		;=$00a	;Analog Comparator Interrupt Vector Address
;	rjmp	_RTOS_ACI
	reti

_opcodes:
_noop:		rjmp	c_noop
_halt:		rjmp	c_halt
_xcolon:	rjmp	c_xcolon
_xlit:		rjmp	c_xlit
_0:		rjmp	c_0
_char:
_1:		rjmp	c_1
_cell:
_2:		rjmp	c_2
_minuschar:
_minus1:	rjmp	c_minus1
_minuscell:
_minus2:	rjmp	c_minus2
_xvar:		rjmp	c_xvar
_xconst:	rjmp	c_xconst
_exit:		rjmp	c_exit
_execute:	rjmp	c_exec
_dup:		rjmp	c_dup
_drop:		rjmp	c_drop
_swap:		rjmp	c_swap
_over:		rjmp	c_over
_rot:		rjmp	c_rot
_nip:		rjmp	c_nip
_tuck:		rjmp	c_tuck
_plus:		rjmp	c_plus
_minus:		rjmp	c_minus
_star:		rjmp	c_star
_slashmod:	rjmp	c_slashmod
_uslashmod:	rjmp	c_uslashmod
_and:		rjmp	c_and
_or:		rjmp	c_or
_xor:		rjmp	c_xor
_shl:		rjmp	c_shl
_shr:		rjmp	c_shr
_bsz:		rjmp	c_bsz
_negate:	rjmp	c_negate
_inv:		rjmp	c_inv
_charplus:
_1plus:		rjmp	c_1plus
_charminus:
_1minus:	rjmp	c_1minus
_cellplus:
_2plus:		rjmp	c_2plus
_less:		rjmp	c_less
_lessequal:	rjmp	c_lessequal
_gt:		rjmp	c_gt
_gtequal:	rjmp	c_gtequal
_uless:		rjmp	c_uless
_ulessequal:	rjmp	c_ulessequal
_ugt:		rjmp	c_ugt
_ugtequal:	rjmp	c_ugtequal
_equal:		rjmp	c_equal
_nequal:	rjmp	c_nequal
_zequal:	rjmp	c_zequal
_zless:		rjmp	c_zless
_fetch:		rjmp	c_fetch
_cfetch:	rjmp	c_cfetch
_store:		rjmp	c_store
_cstore:	rjmp	c_cstore
_spfetch:	rjmp	c_spfetch
_spstore:	rjmp	c_spstore
_rpfetch:	rjmp	c_rpfetch
_rpstore:	rjmp	c_rpstore
_tor:		rjmp	c_tor
_rfrom:		rjmp	c_rfrom
_rfetch:	rjmp	c_rfetch
_rdrop:		rjmp	c_rdrop
_skip:		rjmp	c_skip
_scan:		rjmp	c_scan
_cmoveup:	rjmp	c_moveup
_tocmove:	rjmp	c_tocmove
_cscan:		rjmp	c_cscan
_mtext:		rjmp	c_mtext
_fill:		rjmp	c_fill
_xbranch:	rjmp	c_xbranch
_xfbranch:	rjmp	c_fbranch
_lookup:	rjmp	c_lookup
_trinit:	rjmp	c_trinit
_qrxrdy:	rjmp	c_qrxrdy
_rxfetch:	rjmp	c_rxfetch
_txstore:	rjmp	c_txstore
_xuser:		rjmp	c_user
_xslit:		rjmp	c_xslit
_qdup:		rjmp	c_qdup
_plusstore:	rjmp	c_plusstore
_off:		rjmp	c_off
_on:		rjmp	c_on
_dplus:		rjmp	c_dplus
_udstar:	rjmp	c_udstar
_udslashmod:	rjmp	c_udslashmod
_dnegate:	rjmp	c_dnegate
_xdefer:	rjmp	c_xdefer
_2dup:		rjmp	c_2dup
_2drop:		rjmp	c_2drop
_2swap:		rjmp	c_2swap
_2store:	rjmp	c_2store
_2fetch:	rjmp	c_2fetch
_digitq:	rjmp	c_digitq


.macro	next
	rjmp	_next
.endm

.macro	next2
	rjmp	_next2
.endm


_Main:
	ldwi	temp, rsp-1
	outw	sp, temp

	clr	zero
	clr	one
	inc	one
		
;	clr	iFlags

	;
	; Enable external RAM
	;

	ldi	templ, (1<<SRE) ;|(1<<SRW)
	out	MCUCR, templ


	ldwi	x, bootStart
	ldwi	z, ( BootCode * 2)
	ldwi	y, ( BootCodeEnd *2)
	
BootCodeCopy:
	lpm
	adiw	zl, 1
	st	x+, r0
	
	cp	zl, yl
	brne	BootCodeCopy
	cp	zh, yh
	brne	BootCodeCopy	


	ldwi	x, bootStart
	ldwi	y, csp
	ldwi	tos, 0x55AA
	
	rcall	inituart

	ldwi	x, bootStart
	next

; ===== inner interpreter

docol:
	pushw	x
	ldw	x, z

_next:
_none:

;	sbrc	iFlags, fIntercept
;	rjmp	intercept
	
_doGo:
	nextw	z

_next2:
	tst	zh
	brne	docol
	ijmp




c_noop:
	next


;\ ----- PRIMITIVES -----
;\
;\D HALT ( --> ) M-- | HALT THE MACHINE
;:H HALT    FF FF             \ ILLEGAL INSTRUCTION, STOPS EMULATOR
c_halt:
	rjmp	c_halt


;\D (:) ( ; A --> A' ) M-- | ADDRESS LIST INTERPRETER
;:H (:)
c_xcolon:
	next


;\D (LIT) ( --> N ) M-- | PUSH INLINE LITERAL NUMBER
;:H (LIT)
c_xlit:
	dpush	tos
	nextw	tos
	next

c_0:
	dpush	tos
	ldwi	tos,0
	next
	
c_1:
	dpush	tos
	ldwi	tos,1
	next
	
c_2:
	dpush	tos
	ldwi	tos,2
	next
	
c_minus1:
	dpush	tos
	ldwi	tos, -1
	next
	
c_minus2:
	dpush	tos
	ldwi	tos, -2
	next
	
	

;\D (VAR) ( --> A ) M-- | RUN TIME FOR VARIABLES
;:H (VAR)
c_xvar:
	dpush	tos
	ldw	tos, x
	popw	x
	next


;\D (CONST) ( --> N ) M-- | RUN TIME FOR CONSTANTS
;:H (CONST)
c_xconst:
	dpush	tos
	nextw	tos
	popw	x
	next



;\D EXIT ( ; A --> ) M-- | RETURN FROM THREAD
;:H EXIT
c_exit:
	popw	x
	next


;\D EXEC ( A --> ) M-- | EXECUTE WORD
;:H EXEC
c_exec:
	ldw	z, tos
	dpop	tos
	next2


;\D DUP ( N --> N N ) M-- | DUPLICATE TOS
;:H DUP
c_dup:
	dpush	tos
	next


;\D DROP ( N --> ) M-- | DISCARD TOS
;:H DROP
c_drop:
	dpop	tos
	next


;\D SWAP ( N M --> M N ) M-- | SWAP TOS AND TOS-1
;:H SWAP
c_swap:
	dpop	temp
	dpush	tos
	ldw	tos, temp
	next


;\D OVER ( N M --> N M N ) M-- | DUPLICATE TOS-1
;:H OVER
c_over:
	dpush	tos
	pick	2, tos
	next


;\D ROT ( N M K --> M K N ) M-- | ROTATE STACK UP
;:H ROT
c_rot:
	dpop	temp		; M
	dpop	temp2		; N
	
	dpush	temp		; M
	dpush	tos		; K
	ldw	tos, temp2	; N
	next


;X NIP    x1 x2 -- x2           per stack diagram
c_nip:
	dpop	temp
	next
	

;X TUCK   x1 x2 -- x2 x1 x2     per stack diagram
c_tuck:
	dpop	temp		; x1
	
	dpush	tos		; x2
	dpush	temp		; x1
	next


;\D + ( N M --> N+M ) M-- | SUM
;:H +
c_plus:
	dpop	temp		; N
	addw	tos, temp	; N + M
	next


;\D - ( N M --> N-M ) M-- | DIFFERENCE
;:H -
c_minus:
	dpop	temp		; N
	subw	temp, tos	; N -M
	ldw	tos, temp
	next


;\D * ( N M --> N*M ) M-- | PRODUCT
;:H *
c_star:
	dpop	temp
	next


;\D /MOD ( N M --> N/M N MOD M ) M-- | QUOTIENT+MODULUS
;:H /MOD
c_slashmod:
	dpop	temp
	next


;\D U/MOD ( U V --> U/V U MOD V ) M-- | UNSIGNED QUOT+MOD
;:H U/MOD
c_uslashmod:
	dpop	temp
	next


;\D AND ( U V --> U/\V ) M-- | BITWISE LOGICAL PRODUCT
;:H AND
c_and:
	dpop	temp		; U
	andw	tos, temp	; U and V
	next


;\D OR ( U V --> U\/V ) M-- | BITWISE LOGICAL SUM
;:H OR
c_or:
	dpop	temp		; U
	orw	tos, temp	; U or V
	next
	

;\D XOR ( U V --> U XOR V ) M-- | BITWISE LOGICAL EXCLUSIVE OR
;:H XOR
c_xor:
	dpop	temp		; U
	xorw	tos, temp	; U xor V
	next


;\D SHL ( U V --> U SHL V ) M-- | BITWISE LEFT SHIFT
;:H SHL
c_shl:
	dpop	temp
	next


;\D SHR ( U V --> U SHR V ) M-- | BITWISE RIGHT SHIFT
;:H SHR
c_shr:
	dpop	temp
	next


;\D BSZ ( U --> V ) M-- | BITWISE SCAN FOR ZERO
;:H BSZ
c_bsz:
	next


;\D NEG ( N --> -N ) M-- | NEGATION
;:H NEG
c_negate:
	com	tosl
	com	tosh
	subi	tosl,-1
	sbci	tosh,-1
	next


;\D INV ( U --> INV U ) M-- | BITWISE COMPLEMENT
;:H INV
c_inv:
	notw	tos
	next


;\D 1+ ( N --> N+1 ) M-- | INCREMENT
;:H 1+
c_1plus:
	adiw	tosl, 1
	next


;\D 1- ( N --> N-1 ) M-- | DECREMENT
;:H 1-
c_1minus:
	sbiw	tosl, 1
	next

;\D 2+ ( N --> N+2 ) M-- | INCREMENT
;:H 2+
c_2plus:
	adiw	tosl, 2
	next


;\D < ( N M --> N<M ) M-- | 'LESS THAN' PREDICATE
;:H <
c_less:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, M
	brlt	c_lesstrue
	setfalse
	next
	
c_lesstrue:
	settrue
	next
	


;\D <= ( N M --> N<=M ) M-- | 'LESS THAN/EQUAL TO' PREDICATE
;:H <=
c_lessequal:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, M
	brlt	c_lesstrue
	breq	c_lesstrue
	setfalse
	next


;\D > ( N M --> N>M ) M-- | 'GREATER THAN' PREDICATE
;:H >
c_gt:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, N
	brlt	c_gtfalse
	breq	c_gtfalse
	settrue
	next
	
c_gtfalse:
	setfalse
	next


;\D >= ( N M --> N>=M ) M-- | 'GREATER THAN' PREDICATE
;:H >=
c_gtequal:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, N
	brlt	c_gtfalse
	settrue
	next


;\D U< ( U V --> U<V ) M-- | 'UNSIGNED LESS' PREDICATE
;:H U<
c_uless:
	dpop	temp		; U
	cmpw	temp, tos	; cpw U, V
	brlo	c_ulesstrue
	setfalse
	next
	
c_ulesstrue:
	settrue
	next

;\D U<= ( U V --> U<=V ) M-- | 'UNSIGNED LESS/EQUAL' PREDICATE
;:H U<=
c_ulessequal:
	dpop	temp		; U
	cmpw	temp, tos	; cpw U, V
	brlo	c_ulesstrue
	breq	c_ulesstrue
	setfalse
	next


;\D U> ( U V --> U>V ) M-- | 'UNSIGNED GREATER' PREDICATE
;:H U>
c_ugt:
	dpop	temp		; U
	cmpw	temp, tos	; cpw U, V
	brlo	c_ugtfalse
	breq	c_ugtfalse
	settrue
	next
	
c_ugtfalse:
	setfalse
	next


;\D U>= ( U V --> U>=V ) M-- | 'UNSIGNED GREATER/EQUAL' PRED.
;:H U>=
c_ugtequal:
	dpop	temp		; U
	cmpw	temp, tos	; cpw U, V
	brlo	c_ugtfalse
	settrue
	next


;\D = ( N M --> N=M ) M-- | 'EQUAL TO' PREDICATE
;:H =
c_equal:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, M
	brne	c_equalfalse
	settrue
	next
	
c_equalfalse:
	setfalse
	next


;\D <> ( N M --> N<>M ) M-- | 'NOT EQUAL TO' PREDICATE
;:H <>
c_nequal:
	dpop	temp		; N
	cmpw	temp, tos	; cpw N, M
	breq	c_equalfalse
	settrue
	next


;\D NOT ( F --> NOT F ) M-- | LOGICAL COMPLEMENT
;:H NOT
c_zequal:
	or	tosl, tosh
	breq	c_zequalset
	ldwi	tos, 0
	next
	
c_zequalset:
	ldwi	tos, 0xffff
	next
	
c_zless:
	sbrs	tosh, 7
	rjmp	c_zlessfalse
	settrue
	next
	
c_zlessfalse:
	setfalse
	next				


;\D @ ( A --> N ) M-- | INDIRECTION
;:H @
c_fetch:
	ldw	z, tos		; A
	getw	tos		; N
	next


;\D C@ ( A --> C ) M-- | BYTE INDIRECTION
;:H C@
c_cfetch:
	ldw	z, tos		; A
	getc	tos		; C
	next


;\D ! ( N A --> ) M-- | STORE MACHINE WORD
;:H !
c_store:
	ldw	z, tos		; A
	dpop	tos		; N
	putw	tos
	dpop	tos
	next
	

;\D C! ( C A --> ) M-- | STORE BYTE
;:H C!
c_cstore:
	ldw	z, tos		; A
	dpop	tos		; N
	putc	tos
	dpop	tos
	next



;\D SP@ ( --> A ) M-- | PUSH STACK POINTER
;:H SP@
c_spfetch:
	ldw	temp, y
	dpush	tos
	ldw	tos, temp
	next
	


;\D SP! ( A --> ? ) M-- | POP STACK POINTER
;:H SP!
c_spstore:
	ldw	y, tos
	next



;\D RP@ ( --> A ) M-- | PUSH RETURN STACK POINTER
;:H RP@
c_rpfetch:
	dpush	tos
	inw	tos, sp
	next


;\D RP! ( A --> ; --> ? ) M-- | POP RETURN STACK POINTER
;:H RP!
c_rpstore:
	outw	sp, tos
	dpop	tos
	next


;\D >R ( N --> ; --> N ) M-- | TRANSFER VALUE TO RSTACK
;:H >R
c_tor:
	pushw	tos
	dpop	tos
	next


;\D R> ( --> N ; N --> ) M-- | TRANSFER VALUE FROM RSTACK
;:H R>
c_rfrom:
	dpush	tos
	popw	tos
	next


;\D R@ ( --> N ) M-- | COPY VALUE FROM RSTACK
;:H R@
c_rfetch:
	dpush	tos
	popw	tos
	pushw	tos
	next
	

;\D RDROP ( --> ; N --> ) M-- | DROP TOP OF RSTACK
;:H RDROP
c_rdrop:
	popw	temp
	next
	



;Z SKIP   c-addr u c -- c-addr' u'
c_skip:
	ldw	temp, tos	; c
	dpop	tos		; u
	dpop	z		; c-addr
	
c_skip1:
	testz	tos
	breq	c_skip2
	
	ld	temp2l, z
	cp	temp2l, templ
	brne	c_skip2
	
	adiw	zl, 1
	sbiw	tosl, 1
	rjmp	c_skip1
	
c_skip2:
	dpush	z		; c-adr
	next			; u in tos
	


;Z SCAN    c-addr u c -- c-addr' u'
c_scan:
	ldw	temp, tos	; c
	dpop	tos		; u
	dpop	z		; c-addr
	
c_scan1:
	testz	tos
	breq	c_scan2
	
	ld	temp2l, z
	cp	temp2l, templ
	breq	c_scan2
	
	adiw	zl, 1
	sbiw	tosl, 1
	rjmp	c_scan1
	
c_scan2:
	dpush	z		; c-adr
	next			; u in tos
	

;\D CMOVE> ( DST SRC N --> ) M-- | MOVE MEMORY REGION UP
;:H CMOVE>
c_moveup:
	pushw	x
	dpop	x		; SRC
	dpop	z		; DST

	addw	x, tos		; end of SRC
	addw	z, tos		; end of DST
		
c_moveup1:
	testz	tos
	breq	c_moveup2
	
	ld	templ, -x
	st	-z, templ
	sbiw	tosl, 1
	rjmp	c_moveup1
	
c_moveup2:	
	popw	z
	next



;\D <CMOVE ( DST SRC N --> ) M-- | MOVE MEMORY REGION DOWN
;:H <CMOVE
c_tocmove:
	pushw	x
	dpop	x		; SRC
	dpop	z		; DST
	
c_tocmove1:
	testz	tos		; N
	breq	c_tocmove2
	
	ld	templ, z+
	st	x+, templ
	sbiw	tosl, 1
	rjmp	c_tocmove1
	
c_tocmove2:
	dpop	tos
	popw	x
	next



;\D CSCAN ( A N C --> A|0 ) M-- | SEARCH BYTE IN MEMORY
;:H CSCAN
c_cscan:
	dpop	temp		; N
	dpop	z		; A
	
c_cscan1:
	testz	temp
	breq	c_cscan3
	
	ld	tosh, z
	cp	tosl, tosh
	breq	c_cscan2
	
	adiw	zl, 1
	decw	temp
	rjmp	c_cscan1
	
c_cscan2:
	ldw	tos, z
	next

c_cscan3:
	ldwi	tos, 0
	next	

	

;\D -TEXT ( A1 A2 N --> N ) M-- | COMPARE STRINGS
;:H -TEXT
c_mtext:
	pushw	x
	dpop	x		; A2
	dpop	z
	
c_mtest1:
	testz	tos
	breq	c_mtest2
	
	ld	templ, x+
	ld	temph, z+
	cp	templ, temph
	breq	c_mtest2
	
	sbiw	tosl, 1
	rjmp	c_mtest1
	
c_mtest2:
	popw	x
	next
	


;\D FILL ( A N C --> ) M-- | FILL MEMORY REGION
;:H FILL
c_fill:
	dpop	temp		; N
	dpop	z		; A
	
c_fill1:
	testz	temp
	breq	c_fill2	
	putc	tos
	decw	temp
	rjmp	c_fill1
	
c_fill2:	
	dpop	tos
	next


;\D (BR) ( --> ) M-- | BRANCH TO INLINE ADDRESS
;:H (BR)
c_xbranch:
	nextw	temp
	ldw	x, temp
	next


;\D (BF) ( F --> ) M-- | BRANCH ON FALSE TO INLINE ADDRESS
;:H (BF)
c_fbranch:
	or	tosl, tosh
	dpop	tos
	breq	c_xbranch
	
	nextw	temp
	next


;\D LOOKUP ( A X --> 0|A -1 ) M-- | FIND LFA OF LEXICON ENTRY
;:H LOOKUP
c_lookup:
	pushw	x
	
	dpop	x		; A
	
c_lookup1:
	ldw	z, tos		; x

	ldw	temp2, x	; save A
			
	adiw	zl, 2 +2 +1	; >Name
	ld	templ, z+	; get lex. name length
	andi	templ, 0x7f	; strip immed bit
	ld	temph, x+	; get input name length
	cp	templ, temph
	brne	c_lookup4
	
	tst	templ
	breq	c_lookup3

c_lookup2:	
	ld	temp3l, x+ 
	ld	temp3h, z+
	cp	temp3l, temp3h
	brne	c_lookup4
	dec	templ
	brne	c_lookup2
	
c_lookup3:
	dpush	tos		; nos = link
	settrue			; tos = -1
	popw	x
	next
	
c_lookup4:
	ldw	x, temp2	;restore A
	ldw	z, tos		;restore X
	getw	tos		;get link
	testz	tos
	brne	c_lookup1
	
	setfalse		; tos = 0
	popw	x
	next



;\D TRINIT ( --> ) M-- | TRANSMITTER/RECEIVER INIT 9.6/8N1
;:H TRINIT
c_trinit:
	ldi	templ, (1<<rxen) + (1<<txen)
	out	ucr, templ
	ldi	templ, baudconstant
	out	ubrr, templ
	next
	


;\D ?RXRDY ( --> F ) M-- | AUXILARY RECEIVER READY?
;:H ?RXRDY
c_qrxrdy:
	dpush	tos
	sbis	usr, rxc
	rjmp	c_qrxrdy1
	settrue
	next
	
c_qrxrdy1:
	setfalse
	next

;\D RX@ ( --> C ) M-- | RECEIVE CHAR FROM AUXILARY PORT
;:H RX@
c_rxfetch:
	dpush	tos
c_rxfetch1:
	sbis	usr, rxc
	rjmp	c_rxfetch1

	in	tosl, udr
	clr	tosh
	next



;\D TX! ( C --> ) M-- | TRANSMIT CHAR TO AUXILARY PORT
;:H TX!
c_txstore:
c_txstore1:
	sbis	usr, udre
	rjmp	c_txstore1

	out	udr, tosl
	dpop	tos
	next
	
	
c_user:
	dpush	tos
	ldwi	z, _user
	getw	tos
	nextw	z
	addw	z, z
;	addw	z, tos
	addw	tos, z
;	getw	tos
	popw	x
	next	


c_xslit:
	dpush	tos
	nextc	tos
	dpush	x
	addw	x, tos
	next


c_qdup:
	testz	tos
	breq	c_qdup1
	dpush	tos

c_qdup1:
	next	



;C +!     n/u a-addr --       add cell to memory
c_plusstore:
	ldw	z, tos
	getw	temp
	dpop	temp2
	addw	temp, temp2
	ldw	z, tos
	putw	temp
	dpop	tos
	next

c_off:
	ldwi	temp, 0
	rjmp	c_on_off

c_on:
	ldwi	temp, -1
c_on_off:
	ldw	z, tos
	putw	temp
	dpop	tos
	next


;X D+       d1 d2 -- d         add double to double
c_dplus:
	dpop	temp		; d2l		
	dpop	temp2		; d1h
	dpop	temp3		; d1l
	
	add	templ, temp3l	; d2l + d1l
	adc	temph, temp3h
	adc	tosl, temp2l	; d2h + d1h
	adc	tosh, temp2h
	
	dpush	temp
	next
	
	
;Z UD*      ud1 d2 -- ud3      32*32->32 multiply
c_udstar:
	dpop	temp		; d2l
	dpop	temp3		; d1h
	dpop	temp2		; d1l
	
	rcall	umul
	dpush	temp		; dl
	next


;Z UD*      ud1 d2 -- md3 d4      32/32->32 mod result
c_udslashmod:
	ldw	temp3, tos	; d2h
	dpop	temp2		; d2l
	dpop	tos		; d1h
	dpop	temp		; d1l
	
	rcall	udiv
	
	dpush	reml		; md3l
	dpush	remh		; md3h
	dpush	temp		; d4l
;	ldw	tos, temp3	; d4h
	next


c_dnegate:
	dpop	temp		; dl

	com	templ		; dl
	com	temph
	com	tosl		; dh
	com	tosh
	subi	templ,-1
	sbci	temph,-1
	sbci	tosl,-1
	sbci	tosh,-1
	
	dpush	temp
	next

c_xdefer:
	nextw	z
	tst	zh
	brne	c_xdefer1
	popw	x
	next2
	
c_xdefer1:
	ldw	x, z
	next



;C 2DUP   x1 x2 -- x1 x2 x1 x2   dup top 2 cells
c_2dup:
	pick	0, temp
	dpush	tos
	dpush	temp
	next


;C 2DROP  x1 x2 --          drop 2 cells
c_2drop:
	dpop	tos
	dpop	tos
	next
	
			
;C 2SWAP  x1 x2 x3 x4 -- x3 x4 x1 x2  per diagram
c_2swap:
	dpop	temp3		; x3
	dpop	temp2		; x2
	dpop	temp		; x1
	
	dpush	temp3		; x3
	dpush	tos		; x4
	dpush	temp
	ldw	tos, temp2
	next


;C 2@    a-addr -- x1 x2    fetch 2 cells
;   DUP CELL+ @ SWAP @ ;
;   the lower address will appear on top of stack
c_2fetch:
	ldw	z, tos		; a-addr
	getw	tos
	getw	temp
	dpush	temp
	next
	

;C 2!    x1 x2 a-addr --    store 2 cells
;   SWAP OVER ! CELL+ ! ;
;   the top of stack is stored at the lower adrs
c_2store:
	ldw	z, tos		; a-addr
	dpop	temp		; x2
	dpop	tos		; x1
	putw	temp
	putw	tos
	
	dpop	tos
	next


;Z DIGIT?   c -- n -1   if c is a valid digit
;Z            -- x  0   otherwise
c_digitq:
	dpop	temp			; c

	ldw	temp2, temp		;save for error
	
	tst	temph			
	brne	_digitqFalse
	cpi	templ, 'a'
	brlo	_digitq1
	cpi	templ, 'z'+1
	brsh	_digitqFalse
	ori	templ, 0x20	;uppercase

_digitq1:	
	cpi	templ, '0'
	brlo	_digitqFalse
	cpi	templ, '9'+1
	brlo	_digitqTrue
	
	cpi	templ, 'A'
	brlo	_digitqFalse
	cpi	templ, 'Z' +1
	brsh	_digitqFalse
	subi	templ, 7	;'A' will folow '9'
	
_digitqTrue:
	subi	templ, '0'	;MANT2 = 0 .. 35
	cp	templ, tosl	;digit <= base
	brsh	_digitqFalse
	
	dpush	temp		;put num
	settrue
	next
		

_digitqFalse:
	dpush	temp2		;put back error char
	setfalse
	next


	
	
inituart:
	ldi	templ, (1<<rxen) + (1<<txen)
	out	ucr, templ
	ldi	templ, baudconstant
	out	ubrr, templ
	ret


.include "math.asm"


BootCode:

.equ immed = 1

.set link = 0

  .dw _xbranch, _cold
  
  
c_user_:	.dw _user0
.equ _user = ((c_user_ - bootCode)*2) + bootStart
	
c_user0_:
.equ _user0 = ((c_user0_ - bootCode)*2) + bootStart

s0_:		.dw csp
r0_:		.dw rsp

toin_:		.dw 0
base_:		.dw 10
state_:		.dw 0
dp_:		.dw _last


ticksource_:	.dw 0, 0
latest_:	.dw _dict0	

tib_:
  .db " 1234 .                             "
  .db "                                    "
  .db "                                    "

;      123456789012345678901234567890
  .db "                              "
pad_:
hld_:		.dw 0


.equ userend = c_user0_ + 0x080

  .org userend
  
; ALIGNMENT AND PORTABILITY OPERATORS ===========
   
  
  
  
; SYSTEM VARIABLES & CONSTANTS ==================

;C BL      -- char            an ASCII space
c_bl:
.equ _bl = ((c_bl - bootCode)*2) + bootStart
  .dw _xconst, ' '

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _bl
  .db -1, 2, "BL"

  
;Z r0       -- a-addr     end of return stack
c_r0:
.equ _r0 = ((c_r0 - bootCode)*2) + bootStart
  .dw _xuser, r0_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _r0
  .db -1, 2, "R0"


;Z s0       -- a-addr     end of parameter stack
c_s0:
.equ _s0 = ((c_s0 - bootCode)*2) + bootStart
  .dw _xuser, s0_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _s0
  .db -1, 2, "S0"



;Z tibsize  -- n         size of TIB
c_tibsize:
.equ _tibsize = ((c_tibsize - bootCode)*2) + bootStart
  .dw _xconst, 80

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _tibsize
  .db -1, 7, "tibsize",0
  

;X tib     -- a-addr     Terminal Input Buffer
c_tib:
.equ _tib = ((c_tib - bootCode)*2) + bootStart
  .dw _xuser, tib_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _tib
  .db -1, 3, "TIB",0


;X PAD     -- a-addr     PAD Buffer
c_pad:
.equ _pad = ((c_pad - bootCode)*2) + bootStart
  .dw _xuser, pad_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _pad
  .db -1, 3, "PAD",0


;X HLD     -- a-addr     HLD
c_hld:
.equ _hld = ((c_hld - bootCode)*2) + bootStart
  .dw _xuser, hld_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _hld
  .db -1, 3, "HLD",0


;C >IN     -- a-addr        holds offset into TIB
;  2 USER >IN
c_toin:
.equ _toin = ((c_toin - bootCode)*2) + bootStart
  .dw _xuser, toin_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _toin
  .db -1, 3, ">IN",0


;C BASE    -- a-addr       holds conversion radix
c_base:
.equ _base = ((c_base - bootCode)*2) + bootStart
  .dw _xuser, base_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _base
  .db -1, 4, "BASE"


;C STATE   -- a-addr       holds compiler state
c_state:
.equ _state = ((c_state - bootCode)*2) + bootStart
  .dw _xuser, state_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _state
  .db -1, 4, "STATE",0


;Z dp      -- a-addr       holds dictionary ptr
;  8 USER DP
c_dp:
.equ _dp = ((c_dp - bootCode)*2) + bootStart
  .dw _xuser, dp_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dp
  .db -1, 2, "DP"


;Z 'source  -- a-addr      two cells: len, adrs
; 10 USER 'SOURCE
c_ticksource:
.equ _ticksource = ((c_ticksource - bootCode)*2) + bootStart
  .dw _xuser, ticksource_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _ticksource
  .db -1, 7, "'SOURCE",0

;Z latest    -- a-addr     last word in dict.
c_latest:
.equ _latest = ((c_latest - bootCode)*2) + bootStart
  .dw _xuser, latest_  - c_user0_

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _latest
  .db -1, 6, "LATEST"



; ----- CONSOLE I/O -----

;C EMIT     c --    output character to console
c_emit:
.equ _emit = ((c_emit - bootCode)*2) + bootStart
  .dw _xdefer
;  .dw _drop
  .dw _txstore

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _emit
  .db -1, 4, "EMIT"
  

;C KEY      -- c      get character from keyboard
c_key:
.equ _key = ((c_key - bootCode)*2) + bootStart
  .dw _xdefer
;  .dw _dup
  .dw _rxfetch

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _key
  .db -1, 3, "KEY",0




; ARITHMETIC OPERATORS ==========================

;C S>D    n -- d          single -> double prec.
;   DUP 0< ;
c_stod:
.equ _stod = ((c_stod - bootCode)*2) + bootStart
  .dw _dup, _zless
  .dw _exit
  

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _stod
  .db -1, 3, "S>D",0



; INPUT/OUTPUT ==================================


c_tty:
.equ _tty = ((c_tty - bootCode)*2) + bootStart
  .dw _xlit, _rxfetch, _xlit, _key + 2, _store
  .dw _xlit, _txstore, _xlit, _emit + 2, _store
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _tty
  .db -1, 3, "TTY",0
  

;C COUNT   c-addr1 -- c-addr2 u  counted->adr/len
;   DUP CHAR+ SWAP C@ ;
c_count:
.equ _count = ((c_count - bootCode)*2) + bootStart
  .dw _dup, _charplus, _swap, _cfetch
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _count
  .db -1, 5, "COUNT",0
  

;C CR      --               output newline
;   0D EMIT 0A EMIT ;
c_cr:
.equ _cr = ((c_cr - bootCode)*2) + bootStart
  .dw _xlit, 13, _emit, _xlit, 10, _emit
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _cr
  .db -1, 2, "CR"
  

;C SPACE   --               output a space
;   BL EMIT ;
c_space:
.equ _space = ((c_space - bootCode)*2) + bootStart
  .dw _bl, _emit
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _space
  .db -1, 5, "SPACE",0
  


;Z umin     u1 u2 -- u      unsigned minimum
;   2DUP U> IF SWAP THEN DROP ;
c_umin:
.equ _umin = ((c_umin - bootCode)*2) + bootStart
  .dw _2dup, _ugt
  .dw _xfbranch, ( c_umin1 - bootCode) *2  + bootStart
  .dw _swap
c_umin1:
  .dw _drop
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _umin
  .db -1, 4, "UMIN"
  


;Z umax    u1 u2 -- u       unsigned maximum
;   2DUP U< IF SWAP THEN DROP ;
c_umax:
.equ _umax = ((c_umax - bootCode)*2) + bootStart
  .dw _2dup, _uless
  .dw _xfbranch, ( c_umax1 - bootCode) *2  + bootStart
  .dw _swap
c_umax1:
  .dw _drop
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _umax
  .db -1, 4, "UMAX"


c_accept:
.equ _accept = ((c_accept - bootCode)*2) + bootStart
  .dw _xdefer
;  .dw _xacceptboot
  .dw _xaccept

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _accept
  .db -1, 6, "ACCEPT"

c_xacceptboot:
.equ _xacceptboot = ((c_xacceptboot - bootCode)*2) + bootStart
 .dw _nip, _exit


c_useraccept:
.equ _useraccept = ((c_useraccept - bootCode)*2) + bootStart
  .dw _xlit, _xaccept, _xlit, _accept + 2, _store
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _useraccept
  .db -1, 4, ">TTY"
  


;C ACCEPT  c-addr +n -- +n'  get line from term'l
;   OVER + 1- OVER      -- sa ea a
;   BEGIN KEY           -- sa ea a c
;   DUP 0D <> WHILE
;       DUP EMIT        -- sa ea a c
;       DUP 8 = IF  DROP 1-    >R OVER R> UMAX
;             ELSE  OVER C! 1+ OVER UMIN
;       THEN            -- sa ea a
;   REPEAT              -- sa ea a c
;   DROP NIP SWAP - ;
c_xaccept:
.equ _xaccept = ((c_xaccept - bootCode)*2) + bootStart
  .dw _over, _plus, _1minus, _over
c_accept1:
  .dw _key
  .dw _dup, _xlit, 13, _nequal
  .dw _xfbranch, ( c_accept8 - bootCode) *2  + bootStart
  
  .dw _dup, _emit
  .dw _dup, _xlit, 8, _equal
  .dw _xfbranch, ( c_accept6 - bootCode) *2  + bootStart
  
  .dw _drop, _1minus, _tor, _over, _rfrom, _umax
  .dw _xbranch, ( c_accept7 - bootCode) *2  + bootStart
  
c_accept6:
  .dw _over, _cstore, _1plus, _over, _umin
  
c_accept7:
  .dw _xbranch, ( c_accept1 - bootCode) *2  + bootStart

c_accept8:
;  .dw _noop
  .dw _drop, _nip, _swap, _minus
  .dw _exit
  

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _xaccept
  .db -1, 8, "(accept)"



;C TYPE    c-addr +n --     type line to term'l
;   ?DUP IF
;     OVER + SWAP DO I C@ EMIT LOOP
;   ELSE DROP THEN ;
c_type:
.equ _type = ((c_type - bootCode)*2) + bootStart
c_type1:
  .dw _qdup
  .dw _xfbranch, ( c_type2 - bootCode) *2  + bootStart
  .dw _tor, _dup, _cfetch, _emit, _charplus, _rfrom, _1minus
  .dw _xbranch, ( c_type1 - bootCode) *2  + bootStart

c_type2:
  .dw _drop
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _type
  .db -1, 4, "TYPE"
  

; NUMERIC OUTPUT ================================


;: ABS DUP 0< IF NEGATE THEN ;
c_abs:
.equ _abs = ((c_abs - bootCode)*2) + bootStart
  .dw _dup, _zless
  .dw _xfbranch, ( c_abs2 - bootCode) *2  + bootStart
  .dw _negate
c_abs2:
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _abs
  .db -1, 3, "ABS",0


;: DABS DUP 0< IF DNEGATE THEN ;
c_dabs:
.equ _dabs = ((c_dabs - bootCode)*2) + bootStart
  .dw _dup, _zless
  .dw _xfbranch, ( c_dabs2 - bootCode) *2  + bootStart
  .dw _dnegate
c_dabs2:
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dabs
  .db -1, 4, "DABS"


;: HOLD HLD @ 1- HLD ! HLD @ C!  ;
c_hold:
.equ _hold = ((c_hold - bootCode)*2) + bootStart
  .dw _minus1, _hld, _plusstore, _hld, _fetch, _cstore
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dabs
  .db -1, 4, "HOLD"


;: <# PAD HLD ! ;
c_lessnum:
.equ _lessnum = ((c_lessnum - bootCode)*2) + bootStart
  .dw _pad, _hld, _store
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _lessnum
  .db -1, 2, "<#"



;: #>  DROP DROP HLD @ PAD OVER - ;
c_numgt:
.equ _numgt = ((c_numgt - bootCode)*2) + bootStart
  .dw _2drop, _hld, _fetch, _pad, _over, _minus
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _numgt
  .db -1, 2, "#>"


;: #  BASE @ 0 UD/MOD 2SWAP DROP 9 OVER <
;  IF 7 + THEN
;  48 +  NOOP NOOP  HOLD
c_num:
.equ _num = ((c_num - bootCode)*2) + bootStart
  .dw _base, _fetch, _0, _udslashmod, _2swap, _drop
 .dw _noop
  .dw _xlit, 9, _over, _less
  .dw _xfbranch, ( c_num2 - bootCode) *2  + bootStart
  .dw _xlit, 7, _plus
c_num2:  
  .dw _xlit, 48, _plus, _hold
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _num
  .db -1, 1, "#",0


;: sign  0< IF 45 HOLD  THEN ;
c_sign:
.equ _sign = ((c_sign - bootCode)*2) + bootStart
  .dw _zless
  .dw _xfbranch, ( c_sign2 - bootCode) *2  + bootStart
  .dw _xlit, 45, _hold
c_sign2:
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _sign
  .db -1, 4, "sign"


;: #s BEGIN # 2DUP OR 0= UNTIL ;
c_nums:
.equ _nums = ((c_nums - bootCode)*2) + bootStart
c_nums1:
  .dw _num, _2dup, _or, _zequal
  .dw _xfbranch, ( c_nums1 - bootCode) *2  + bootStart
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _nums
  .db -1, 2, "#s"


;: (D.)  2DUP DABS <# #s 2DROP OVER sign #> ;
c_pddot:
.equ _pddot = ((c_pddot - bootCode)*2) + bootStart
  .dw _2dup, _dabs, _lessnum, _nums, _2drop, _over, _sign, _numgt
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _pddot
  .db -1, 4, "(D.)"


;: (.) S>D (D.) ;
c_pdot:
.equ _pdot = ((c_pdot - bootCode)*2) + bootStart
  .dw _stod, _pddot
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _pdot
  .db -1, 3, "(.)",0



;: . (.) TYPE SPACE ;
c_dot:
.equ _dot = ((c_dot - bootCode)*2) + bootStart
  .dw _pdot, _type, _space
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dot
  .db -1, 1, ".",0


;: D. (D.) TYPE SPACE ;  
c_ddot:
.equ _ddot = ((c_ddot - bootCode)*2) + bootStart
  .dw _pddot, _type, _space
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _ddot
  .db -1, 2, "D."

  
  
; DICTIONARY MANAGEMENT =========================

;C HERE    -- addr      returns dictionary ptr
;   DP @ ;
c_here:
.equ _here = ((c_here - bootCode)*2) + bootStart
  .dw _dp, _fetch
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _here
  .db -1, 4, "HERE"
  

;C ALLOT   n --         allocate n bytes in dict
;   DP +! ;
c_allot:
.equ _allot = ((c_allot - bootCode)*2) + bootStart
  .dw _dp, _plusstore
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _allot
  .db -1, 5, "ALLOT",0
  

;C ,    x --           append cell to dict
;   HERE ! 1 CELLS ALLOT ;
c_comma:
.equ _comma = ((c_comma - bootCode)*2) + bootStart
  .dw _here, _store, _cell, _allot
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _comma
  .db -1, 1, ",",0


;C C,   char --        append char to dict
;   HERE C! 1 CHARS ALLOT ;
c_ccomma:
.equ _ccomma = ((c_ccomma - bootCode)*2) + bootStart
  .dw _here, _cstore, _char, _allot
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _ccomma
  .db -1, 2, "C,"
  

  
; INTERPRETER ===================================

c_dotok:
.equ _dotok = ((c_dotok - bootCode)*2) + bootStart
  .dw _xdefer
;  .dw _noop
  .dw _xdotok

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dotok
  .db -1, 3, ".OK",0
  

c_xdotok:
.equ _xdotok = ((c_xdotok - bootCode)*2) + bootStart
  .dw _xslit
  .db 3, "OK."
  .dw _type
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _xdotok
  .db -1, 5, "(.OK)",0
  

c_dotsignon:
.equ _dotsignon = ((c_dotsignon - bootCode)*2) + bootStart
  .dw _xdefer
;  .dw _noop
  .dw _xdotsignon

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _dotsignon
  .db -1, 7, ".signon",0
  

c_xdotsignon:
.equ _xdotsignon = ((c_xdotsignon - bootCode)*2) + bootStart
  .dw _cr, _xslit
  .db 9, "4th 0.99."
  .dw _type
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _xdotsignon
  .db -1, 9, "(.signon)",0
  

; COMPILER ======================================


;C CREATE   --      create an empty definition
c_create:
.equ _create = ((c_create - bootCode)*2) + bootStart

  .dw _here
  .dw _latest, _fetch, _comma, _xlit, _noop, _comma
  .dw _minus1, _ccomma
  .dw _latest, _store
  .dw _bl, _word
  .dw _dup, _cfetch, _1plus

c_create1:
  .dw _qdup
  .dw _xfbranch, ( c_create2 - bootCode) *2  + bootStart
  
  .dw _tor, _dup, _cfetch, _ccomma, _1plus
  .dw _rfrom, _1minus
  .dw _xbranch, ( c_create1 - bootCode) *2  + bootStart
  
c_create2:
;  .dw _noop
  .dw _drop
  .dw _here, _latest, _fetch, _2plus, _store
  .dw _xlit, _xvar, _comma
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _create
  .db -1, 6, "CREATE"
  
  
  
;: [
;  ['] INTERPRET-DO-DEFINED   IS DO-DEFINED
;  ['] INTERPRET-DO-LITERAL   IS DO-LITERAL
;  ['] INTERPRET-DO-UNDEFINED IS DO-UNDEFINED
;  STATE OFF ; IMMEDIATE
c_leftbracket:
.equ _leftbracket = ((c_leftbracket - bootCode)*2) + bootStart
  .dw _xlit, _interpret_do_defined, _xlit, _do_defined+2, _store
  .dw _xlit, _interpret_do_literal, _xlit, _do_literal+2, _store
  .dw _xlit, _interpret_do_undefined, _xlit, _do_undefined+2, _store
  .dw _state, _off
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _leftbracket
  .db -1, 1, "[",0


;: ]
;  ['] COMPILE-DO-DEFINED     IS DO-DEFINED
;  ['] COMPILE-DO-LITERAL     IS DO-LITERAL
;  ['] COMPILE-DO-UNDEFINED   IS DO-UNDEFINED
;  STATE ON
c_rightbracket:
.equ _rightbracket = ((c_rightbracket - bootCode)*2) + bootStart
  .dw _xlit, _compile_do_defined, _xlit, _do_defined+2, _store
  .dw _xlit, _compile_do_literal, _xlit, _do_literal+2, _store
  .dw _xlit, _compile_do_undefined, _xlit, _do_undefined+2, _store
  .dw _state, _on
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _rightbracket
  .db -1, 1, "]",0
  

;C SOURCE   -- adr n    current input buffer
;   'SOURCE 2@ ;        length is at lower adrs
c_source:
.equ _source = ((c_source - bootCode)*2) + bootStart
  .dw _ticksource, _2fetch
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _source
  .db -1, 6, "SOURCE"


;X /STRING  a u n -- a+n u-n   trim string
;   ROT OVER + ROT ROT - ;
c_slashstring:
.equ _slashstring = ((c_slashstring - bootCode)*2) + bootStart
  .dw _rot, _over, _plus, _rot, _rot, _minus
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _slashstring
  .db -1, 7, "/STRING",0


;Z >counted  src n dst --     copy to counted str
;   2DUP C! CHAR+ SWAP CMOVE ;
c_tocounted:
.equ _tocounted = ((c_tocounted - bootCode)*2) + bootStart
  .dw _2dup, _cstore, _charplus, _swap, _tocmove
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _tocounted
  .db -1, 8, ">counted"
 
 
;C WORD   char -- c-addr n   word delim'd by char
;   DUP  SOURCE >IN @ /STRING   -- c c adr n
;   DUP >R   ROT SKIP           -- c adr' n'
;   OVER >R  ROT SCAN           -- adr" n"
;   DUP IF CHAR- THEN        skip trailing delim.
;   R> R> ROT -   >IN +!        update >IN offset
;   TUCK -                      -- adr' N
;   PAD >counted               --
;   PAD                        -- a
;   BL OVER COUNT + C! ;    append trailing blank
c_word:
.equ _word = ((c_word - bootCode)*2) + bootStart
  .dw _dup, _source, _toin, _fetch, _slashstring
  .dw _dup, _tor, _rot, _skip
  .dw _over, _tor, _rot, _scan
  .dw _dup
  .dw _xfbranch, ( c_word2 - bootCode) *2  + bootStart
  .dw _1minus
c_word2:
  .dw _rfrom, _rfrom, _rot, _minus, _toin, _plusstore
  .dw _tuck, _minus
  .dw _here, _xlit, 50, _plus, _dup, _tor, _tocounted
  .dw _rfrom, _bl, _over, _count, _plus, _cstore
;  .dw _noop
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _word
  .db -1, 4, "WORD"
 
 
;C FIND   c-addr -- c-addr 0   if not found
;C                  xt  1      if immediate
;C                  xt -1      if "normal"
c_find:
.equ _find = ((c_find - bootCode)*2) + bootStart
  .dw _dup, _latest, _fetch, _lookup
  .dw _xfbranch, ( c_find9 - bootCode) *2  + bootStart
  .dw _nip
  .dw _cellplus, _dup, _fetch, _swap, _cellplus, _cfetch
  .dw _exit
  
c_find9:
  .dw _0
  .dw _exit  

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _find
  .db -1, 4, "FIND"
  
  
;C >NUMBER  ud adr u -- ud' adr' u'
;C                      convert string to number
;   BEGIN
;   DUP WHILE
;       OVER C@ BASE @ DIGIT?
;       0= IF DROP EXIT THEN
;       >R 2SWAP BASE @ UD*
;       R> M+ 2SWAP
;       1 /STRING
;   REPEAT ;
c_tonumber:
.equ _tonumber = ((c_tonumber - bootCode)*2) + bootStart
c_tonumber1:
  .dw _dup
  .dw _xfbranch, ( c_tonumber9 - bootCode) *2  + bootStart
  .dw _over, _cfetch, _base, _fetch, _digitq
  .dw _zequal
  .dw _xfbranch, ( c_tonumber2 - bootCode) *2  + bootStart
  .dw _drop, _exit

c_tonumber2:
  .dw _tor, _2swap, _base, _fetch, _0, _udstar
  .dw _rfrom, _xlit,0, _dplus, _2swap
  .dw _1, _slashstring
 
  .dw _xbranch, ( c_tonumber1 - bootCode) *2  + bootStart

c_tonumber9:
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _tonumber
  .db -1, 7, ">NUMBER",0  


;Z ?NUMBER  c-addr -- n 1        string->number
;                  -- d 2
;                  -- c-addr 0  if convert error
; DUP COUNT DUP 0= IF
;   NIP EXIT
; THEN
; OVER C@ ASCII - =
; DUP >R IF
;   1- >R 1+ R>
; THEN
; 0 0 2SWAP >NUMBER ?DUP IF
;   1 = SWAP C@ ASCII . = AND IF
;     >R NIP R>
;     >R IF DNEGATE THEN
;     2 EXIT
;   THEN
;     2DROP 0 EXIT
; THEN
;   2DROP NIP 
;   >R IF DNEGATE THEN
;   1 EXIT
;
c_qnumber:
.equ _qnumber = ((c_qnumber - bootCode)*2) + bootStart
; .dw _noop
  .dw _dup, _count, _dup, _zequal
  .dw _xfbranch, ( c_qnumber2 - bootCode) *2  + bootStart
  .dw _nip, _exit
  
c_qnumber2:
  .dw _over, _cfetch, _xlit, '-', _equal
  .dw _dup, _tor
  .dw _xfbranch, ( c_qnumber3 - bootCode) *2  + bootStart
  .dw _1minus, _tor, _1plus, _rfrom
  
c_qnumber3:
  .dw _0, _dup, _2swap, _tonumber
  .dw _qdup
  .dw _xfbranch, ( c_qnumber6 - bootCode) *2  + bootStart
  
  .dw _1, _equal, _swap, _cfetch, _xlit, '.', _equal, _and
  .dw _xfbranch, ( c_qnumber5 - bootCode) *2  + bootStart
  
  .dw _tor, _nip, _rfrom, _rfrom
  .dw _xfbranch, ( c_qnumber4 - bootCode) *2  + bootStart
  .dw _dnegate
c_qnumber4:
  .dw _2
  .dw _exit
  
  
c_qnumber5:
  .dw _rdrop, _2drop, _0
; .dw _noop
  .dw _exit  

c_qnumber6:
  .dw _2drop, _nip, _rfrom
  .dw _xfbranch, ( c_qnumber7 - bootCode) *2  + bootStart
  .dw _negate
c_qnumber7:
  .dw _1
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _qnumber
  .db -1, 7, "?NUMBER",0
  
  

;DEFER LITERAL?      ( str -- n true  |  d true  |  str false )
c_literalq:
.equ _literalq = ((c_literalq - bootCode)*2) + bootStart
  .dw _xdefer
  .dw _qnumber

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _literalq
  .db -1, 8, "LITERAL?"


;DEFER DO-DEFINED    ( cfa -1 | cfa 1  -- ?? )
c_do_defined:
.equ _do_defined = ((c_do_defined - bootCode)*2) + bootStart
  .dw _xdefer
  .dw _interpret_do_defined

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _do_defined
  .db -1, 10, "DO-DEFINED"


;DEFER DO-LITERAL    ( literal -- ?? )
c_do_literal:
.equ _do_literal = ((c_do_literal - bootCode)*2) + bootStart
  .dw _xdefer
  .dw _interpret_do_literal

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _do_literal
  .db -1, 10, "DO-LITERAL"
  

;DEFER DO-UNDEFINED  ( str -- )  
c_do_undefined:
.equ _do_undefined = ((c_do_undefined - bootCode)*2) + bootStart
  .dw _xdefer
  .dw _interpret_do_undefined

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _do_undefined
  .db -1, 12, "DO-UNDEFINED"

  
;: INTERPRET-DO-DEFINED  ( cfa -1 | cfa 1 -- ?? )
;  DROP EXECUTE
c_interpret_do_defined:
.equ _interpret_do_defined = ((c_interpret_do_defined - bootCode)*2) + bootStart
  .dw _drop, _execute
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _interpret_do_defined
  .db -1, 11, "[do-defined",0
  
  
  
;: COMPILE-DO-DEFINED    ( cfa -1 | cfa 1 -- )
;  1- IF   EXECUTE   ( if immediate )
;     ELSE ,         ( if not immediate )
;     THEN
c_compile_do_defined:
.equ _compile_do_defined = ((c_compile_do_defined - bootCode)*2) + bootStart
  .dw _1minus
  .dw _xfbranch, ( c_compile_do_defined2 - bootCode) *2  + bootStart

  .dw _comma
  .dw _exit
    
c_compile_do_defined2:
  .dw _execute
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _compile_do_defined
  .db -1, 11, "]do-defined",0
  


;: INTERPRET-DO-LITERAL ( d -- d | n )
;  DROP ( DOUBLE? 0= IF DROP THEN )
c_interpret_do_literal:
.equ _interpret_do_literal = ((c_interpret_do_literal - bootCode)*2) + bootStart
  .dw _drop
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _interpret_do_literal
  .db -1, 11, "[do-literal",0
    
  
;: COMPILE-DO-LITERAL ( d -- )
;  DOUBLE? IF [COMPILE] DLITERAL ELSE [COMPILE] LITERAL THEN
c_compile_do_literal:
.equ _compile_do_literal = ((c_compile_do_literal - bootCode)*2) + bootStart
  .dw _1minus, _zequal
  .dw _xfbranch, ( c_compile_do_literal2 - bootCode) *2  + bootStart

  .dw _xlit, _xlit, _comma, _comma
  .dw _exit
      
c_compile_do_literal2:
  .dw _swap
  .dw _xlit, _xlit, _comma, _comma
  .dw _xlit, _xlit, _comma, _comma
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _compile_do_defined
  .db -1, 11, "]do-defined",0
  
  
  
    
;: INTERPRET-DO-UNDEFINED ( str -- )
;    COUNT TYPE ."  ?" CR
;  QUIT
c_interpret_do_undefined:
.equ _interpret_do_undefined = ((c_interpret_do_undefined - bootCode)*2) + bootStart
; .dw _noop
  .dw _count, _type
  .dw _xslit
  .db 3, " ??"
  .dw _type, _cr
  .dw _quit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _interpret_do_undefined
  .db -1, 13, "[do-undefined",0
  
  
  

;: COMPILE-DO-UNDEFINED   ( str -- )
;    COUNT TYPE ."  ?" CR
;  COMPILE LOSE
c_compile_do_undefined:
.equ _compile_do_undefined = ((c_compile_do_undefined - bootCode)*2) + bootStart
  .dw _count, _type, _xslit
  .db 3, " ??"
  .dw _type, _cr
  .dw _quit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _compile_do_undefined
  .db -1, 13, "]do-undefined",0
  
  


;: "COMPILE ( str -- ?? )
;  FIND     ( str 0  |   cfa -1   |   cfa 1 )
;  ?DUP
;  IF   DO-DEFINED    ( ??  )
;  ELSE ( DROP )         ( str )
;       LITERAL? ?DUP      ( str false | ?? true )
;       IF    DO-LITERAL        ( ?? )
;       ELSE  DO-UNDEFINED      ( ?? )
;       THEN
;  THEN
c_quotecompile:
.equ _quotecompile = ((c_quotecompile - bootCode)*2) + bootStart
;  .dw _noop
  .dw _find			; FIND
  .dw _qdup			; ?DUP IF
  .dw _xfbranch, ( c_quotecompile2 - bootCode) *2  + bootStart
  
  .dw _do_defined		; DO-DEFINED
  .dw _xbranch, ( c_quotecompile9 - bootCode) *2  + bootStart

c_quotecompile2:		; ELSE
;  .dw _drop			; DROP
  .dw _literalq, _qdup		; LITERAL? ?DUP IF
; .dw _noop
  .dw _xfbranch, ( c_quotecompile3 - bootCode) *2  + bootStart
 
  .dw _do_literal		; DO-LITERAL
  .dw _xbranch, ( c_quotecompile4 - bootCode) *2  + bootStart

c_quotecompile3:		; ELSE
; .dw _noop
  .dw _do_undefined		; DO-UNDEFINED

c_quotecompile4:		; THEN
c_quotecompile9:		; THEN
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _quotecompile
  .db -1, 8, 0x22, "COMPILE"
  
  



;: NEW-INTERPRET  (S -- )
;   'SOURCE 2!  0 >IN !
;  BEGIN   BL WORD   ( str )
;          MORE?     ( str f )  ( flag true if input stream not exhausted )
;  WHILE
;          "COMPILE
;;  REPEAT
;  DROP
c_interpret:
.equ _interpret = ((c_interpret - bootCode)*2) + bootStart
;.dw _noop
  .dw _ticksource, _2store, _0, _toin, _store
  
c_interpret1:			; BEGIN
  .dw _bl, _word, _dup, _cfetch	; BL WORD DUP C@ WHILE
  .dw _xfbranch, ( c_interpret2 - bootCode) *2  + bootStart ; MORE?

  .dw _quotecompile		; "COMPILE REPEAT
  .dw _xbranch, ( c_interpret1 - bootCode) *2  + bootStart
c_interpret2:
  .dw _drop			; DROP
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _interpret
  .db -1, 9, "INTERPRET",0
  
  

;
;C QUIT     --    R: i*x --    interpret from kbd
;   L0 LP !  R0 RP!   0 STATE !
;   BEGIN
;       TIB DUP TIBSIZE ACCEPT  SPACE
;       INTERPRET
;       STATE @ 0= IF CR ." OK" THEN
;   AGAIN ;  
c_quit:
.equ _quit = ((c_quit - bootCode)*2) + bootStart
  .dw _r0, _fetch, _rpstore
  .dw _leftbracket
c_quit1:
  .dw _cr
  .dw _tib, _dup, _tibsize, _accept, _space
  .dw _interpret
  .dw _state, _fetch, _zequal
  .dw _xfbranch, ( c_quit2 - bootCode) *2  + bootStart
  
  .dw _dotok
c_quit2:
  .dw _xbranch, ( c_quit1 - bootCode) *2  + bootStart

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _quit
  .db -1, 4, "QUIT"
  


;C ABORT    i*x --   R: j*x --   clear stk & QUIT
;   S0 SP!  QUIT ;
c_abort:
.equ _abort = ((c_abort - bootCode)*2) + bootStart
  .dw _s0, _fetch, _spstore
  .dw _quit
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _abort
  .db -1, 5, "ABORT",0
  
  

c_cold:
.equ _cold = ((c_cold - bootCode)*2) + bootStart
  .dw _dotsignon
  .dw _abort
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _cold
  .db -1, 4, "COLD"


  

;C :        --      begin a colon definition
;   CREATE HIDE ] !COLON ;
c_colon:
.equ _colon = ((c_colon - bootCode)*2) + bootStart
;  .dw _noop
  .dw _create, _minuscell, _allot, _rightbracket
  .dw _exit  
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _colon
  .db -1, 1, ":",0
  
  
;C ;
;   REVEAL  ,EXIT
;   POSTPONE [  ; IMMEDIATE
  
c_semicolon:
.equ _semicolon = ((c_semicolon - bootCode)*2) + bootStart
  .dw _xlit, _exit, _comma, _leftbracket
;  .dw _noop
  .dw _exit  
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _semicolon
  .db immed, 1, 0x3b,0
  



; CONTROL STRUCTURES ============================

;C IF       -- adrs    conditional forward branch
;   ['] qbranch ,BRANCH  IHERE DUP ,DEST ;
;   IMMEDIATE
c_if:
.equ _if = ((c_if - bootCode)*2) + bootStart
  .dw _xlit, _xfbranch, _comma, _here, _dup, _comma
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _if
  .db immed, 2, "IF"
  


;C THEN     adrs --        resolve forward branch
;   IHERE SWAP !DEST ; IMMEDIATE
c_then:
.equ _then = ((c_then - bootCode)*2) + bootStart
  .dw _here, _swap, _store
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _then
  .db immed, 4, "THEN"


;C ELSE     adrs1 -- adrs2    branch for IF..ELSE
;   ['] branch ,BRANCH  IHERE DUP ,DEST
;   SWAP  POSTPONE THEN ; IMMEDIATE
c_else:
.equ _else = ((c_else - bootCode)*2) + bootStart
  .dw _xlit, _xbranch, _comma, _here, _dup, _comma
  .dw _swap, _then
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _else
  .db immed, 4, "ELSE"



;C BEGIN    -- adrs        target for bwd. branch
;   IHERE ; IMMEDIATE
c_begin:
.equ _begin = ((c_begin - bootCode)*2) + bootStart
  .dw _here
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _begin
  .db immed, 5, "BEGIN",0



;C UNTIL    adrs --   conditional backward branch
;   ['] qbranch ,BRANCH  ,DEST ; IMMEDIATE
;   conditional backward branch
c_until:
.equ _until = ((c_until - bootCode)*2) + bootStart
  .dw _xlit, _xfbranch, _comma, _comma
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _until
  .db immed, 5, "UNTIL",0


;X AGAIN    adrs --      uncond'l backward branch
;   ['] branch ,BRANCH  ,DEST ; IMMEDIATE
;   unconditional backward branch
c_again:
.equ _again = ((c_again - bootCode)*2) + bootStart
  .dw _xlit, _xbranch, _comma, _comma
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _again
  .db immed, 5, "AGAIN",0


;C WHILE    adrs1 -- adrs2 adrs1
;                           branch for WHILE loop
;   POSTPONE IF SWAP ; IMMEDIATE
c_while:
.equ _while = ((c_while - bootCode)*2) + bootStart
  .dw _if, _swap
  .dw _exit

  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _while
  .db immed, 5, "WHILE",0



;C REPEAT   adrs2 adrs1 --     resolve WHILE loop
;   POSTPONE AGAIN POSTPONE THEN ; IMMEDIATE
c_repeat:
.equ _repeat = ((c_repeat - bootCode)*2) + bootStart
  .dw _again, _then
  .dw _exit
  
  .dw link
.set link = ((pc-1-bootCode) *2) + bootStart
  .dw _repeat
  .db immed, 6, "REPEAT"





; =========================================  
  
.include "prims.asm"

; =========================================  
  
.equ _dict0 = link

c_last:
.equ _last = ((c_last - bootCode)*2) + bootStart


BootCodeEnd:

